from PyQt4 import QtCore, QtGui

import draggableicons_rc
from stack import *


class DragWidget(QtGui.QFrame):
    def __init__(self, parent=None):
        super(DragWidget, self).__init__(parent)

        self.setMinimumSize(400, 600)
        self.setFrameStyle(QtGui.QFrame.Sunken | QtGui.QFrame.StyledPanel)
        self.setAcceptDrops(True)
        self.test=0
        self.l=stack.l
        self.val=0
        self.flag=0
        self.x=self.y=0
        self.Icon=[]
        self.bot=0
        self.xlb=self.ylb=0


        self.blocks= [['block1.png',130,50],
                 ['block2.png',200,90],
                 ['block3.png',20,200],
                 ['block4.png',210,340]]
                 

        for i in xrange(4):
            self.Icon.append(0)
            self.Icon[i] = QtGui.QLabel(self)

        self.Icon[0] = QtGui.QLabel(self)
        self.Icon[0].setPixmap(QtGui.QPixmap(':/images/block1.png'))
        self.Icon[0].move(130, 50)
        self.Icon[0].show()
        
        
        self.lb= QtGui.QLineEdit(self)
        self.lb.setText("hello")
        self.lb.move(180,60)
        #self.lb.setMaxLength(3)
        self.lb.show()


    def setlabel( self,x,y):
        x= x+50
        y= y+10
        self.lb.setText("hello")
        self.lb.move(x,y)
        self.lb.show()



    def dragEnterEvent(self, event):
        if event.mimeData().hasFormat('application/x-dnditemdata'):
            if event.source() == self:
                event.setDropAction(QtCore.Qt.MoveAction)
                event.accept()
            else:
                event.acceptProposedAction()
            offset = QtCore.QPoint()
        else:
            event.ignore()

    dragMoveEvent = dragEnterEvent

    def dropEvent(self, event):
        if event.mimeData().hasFormat('application/x-dnditemdata'):
            itemData = event.mimeData().data('application/x-dnditemdata')
            dataStream = QtCore.QDataStream(itemData, QtCore.QIODevice.ReadOnly)

            pixmap = QtGui.QPixmap()
            offset = QtCore.QPoint()
            dataStream >> pixmap >> offset
            newIcon = QtGui.QLabel(self)
            newIcon.setPixmap(pixmap)
            newIcon.move(event.pos() - offset)
            #print(offset)
            newIcon.show()
            child2 = event.pos()-offset
            #print(child2)
            newIcon.setAttribute(QtCore.Qt.WA_DeleteOnClose)

            if event.source() == self:
                event.setDropAction(QtCore.Qt.MoveAction)
                event.accept()
            else:
                event.acceptProposedAction()
            self.xlb= child2.x()
            self.ylb= child2.y()
            #print("drop x: ",test,"  y:",test2)
            #self.setlabel(xlb,ylb)
        else:
            event.ignore()


        #print(self.l)

    def mousePressEvent(self, event):
        v=0
        self.flag=0
        offset = QtCore.QPoint()
        child = self.childAt(event.pos())
        xcor= event.pos().x()
        ycor= event.pos().y()
        #print(event.pos())
        if not child:
            return

        pixmap = QtGui.QPixmap(child.pixmap())

        itemData = QtCore.QByteArray()
        dataStream = QtCore.QDataStream(itemData, QtCore.QIODevice.WriteOnly)
        dataStream << pixmap << QtCore.QPoint(event.pos() - child.pos())

        mimeData = QtCore.QMimeData()
        mimeData.setData('application/x-dnditemdata', itemData)

        drag = QtGui.QDrag(self)
        drag.setMimeData(mimeData)
        drag.setPixmap(pixmap)
        drag.setHotSpot(event.pos() - child.pos())
        tempPixmap = QtGui.QPixmap(pixmap)
        painter = QtGui.QPainter()
        painter.begin(tempPixmap)
        painter.fillRect(pixmap.rect(), QtGui.QColor(127, 127, 127, 127))
        painter.end()
        

        child.setPixmap(tempPixmap)

        if drag.exec_(QtCore.Qt.CopyAction | QtCore.Qt.MoveAction, QtCore.Qt.CopyAction) == QtCore.Qt.MoveAction:
            child.close()
            #self.setlabel(self.xlb,self.ylb)
        else:
            child.show()
            #self.setlabel(self.xlb,self.ylb)
            child.setPixmap(pixmap)

            
    def mouseReleaseEvent(self, event):
        #self.Icon[0] = QtGui.QLabel(self)
        #self.Icon[0].setPixmap(QtGui.QPixmap(':/images/block1.png'))
        #self.Icon[0].hide()
        #self.Icon[0].move(self.xlb,self.ylb)
        #self.Icon[0].show()
        self.setlabel(self.xlb,self.ylb)
            
        

        
                


if __name__ == '__main__':

    import sys

    app = QtGui.QApplication(sys.argv)

    mainWidget = QtGui.QWidget()
    horizontalLayout = QtGui.QHBoxLayout()
    horizontalLayout.addWidget(DragWidget())
    #horizontalLayout.addWidget(DragWidget())

    mainWidget.setLayout(horizontalLayout)
    mainWidget.setWindowTitle(QtCore.QObject.tr(mainWidget, "Draggable Icons"))
    mainWidget.show()

    sys.exit(app.exec_())
